<?php

namespace SIU\SQ\Lib\daos;

use SIU\SQ\Lib\errores\error_negocio;
use SIU\SQ\Lib\constantes;

class dao_facturador extends dao
{
    public function get_lista($filtro = [], $order_by = "ORDER BY id", $limit = "")
    {
        $where = "";
        if (isset($filtro['id'])) {
            $where .= " AND f.id = " . $this->quote($filtro['id']);
        }
        if (isset($filtro['id_reloj_facturador'])) {
            $where .= " AND f.id_reloj_facturador = " . $this->quote($filtro['id_reloj_facturador']);
        }
        $sql = "SELECT
					f.id,
					f.id_ejecucion_proceso,
					f.id_reloj_facturador,
					f.dia_1er_vencimiento,
					f.dia_2do_vencimiento,
					f.id_reloj_facturador_1er_venc,
					f.id_reloj_facturador_2do_venc
				FROM
					facturaciones f
				WHERE 1=1
					$where $order_by $limit;";
        return $this->entorno()->db()->consultar($sql);
    }

    public function get_facturaciones_servicios_instancias($filtro, $order_by = "ORDER BY id", $limit = "")
    {
        $where = "";
        if (isset($filtro['id'])) {
            $where .= " AND fsi.id = " . $this->quote($filtro['id']);
        }
        if (isset($filtro['id_servicio_instancia'])) {
            $where .= " AND fsi.id_servicio_instancia = " . $this->quote($filtro['id_servicio_instancia']);
        }
        if (isset($filtro['id_facturacion'])) {
            $where .= " AND fsi.id_facturacion = " . $this->quote($filtro['id_facturacion']);
        }
        if (isset($filtro['estado'])) {
            $where .= " AND fsi.estado = " . $this->quote($filtro['estado']);
        }
        $sql = "SELECT
					fsi.id,
					fsi.id_servicio_instancia,
					fsi.id_facturacion,
					fsi.estado
				FROM
					facturaciones_servicios_instancias fsi
				WHERE 1=1
					$where $order_by $limit;";
        return $this->entorno()->db()->consultar($sql);
    }

    public function get_tipos_servicios($filtro = array(), $order_by = "ORDER BY id", $limit = "")
    {
        $where = "";
        if (isset($filtro['id'])) {
            $where .= " AND id = " . $this->quote($filtro['id']);
        }
        if (isset($filtro['codigo'])) {
            $where .= " AND codigo = " . $this->quote($filtro['codigo']);
        }
        if (isset($filtro['devenga'])) {
            $where .= " AND devenga = " . $this->quote($filtro['devenga']);
        }

        $sql = "SELECT
					id, 
					codigo, 
					descripcion,
					tiene_instancias,
					estado,
					estado_actualizado_en,
					devenga
				FROM
					tipos_servicios
				WHERE 1 = 1
				    $where $order_by $limit ;";
        return $this->entorno()->db()->consultar($sql);
    }
    public function get_reloj_facturador($filtro = [])
    {
        $select = "";
        $where = "";
        $join = "";
        if (isset($filtro['id'])) {
            $where .= " AND r.id = " . $this->quote($filtro['id']);
        }
        if (isset($filtro['id_mes']) && !isset($filtro['con_mes'])) {
            $select.=" mes,";
            $join.= " join meses m on m.id=r.id_mes";
            $where .= " AND r.id_mes = " . $this->quote($filtro['id']);
        }
        if (isset($filtro['con_mes'])) {
            $select.=" numero_mes as mes,";
            $join.= " join meses m on m.id=r.id_mes";
        }
        if (isset($filtro['id_anio']) && !isset($filtro['con_anio'])) {
            $select.="anio,";
            $join.= " join anios a on a.id=r.id_anio";
            $where .= " AND r.id_anio = " . $this->quote($filtro['id_anio']);
        }
        if (isset($filtro['con_anio'])) {
            $select.="anio,";
            $join.= " join anios a on a.id=r.id_anio";
        }
        if (isset($filtro['anio'])) {
            $join.= " join anios a on a.id=r.id_anio and a.codigo=". $this->quote($filtro['anio']);
        }
        if (isset($filtro['mes'])) {
            $join.= " join meses m on m.id=r.id_mes and m.numero_mes=". $this->quote($filtro['mes']);
        }
        if (isset($filtro['id_reloj_facturador_estado'])) {
            $where .= " AND r.id_reloj_facturador_estado = " . $this->quote($filtro['id_reloj_facturador_estado']);
        }
        $sql = "SELECT
                    $select
        r.id,
        r.codigo,
            r.id_anio,
            r.id_mes
        FROM
        reloj_facturador r
            $join 
        WHERE 1=1
        $where ;";
            return $this->entorno()->db()->consultar($sql);
    }
}
