<?php
namespace SIU\SQ\Lib\daos;

use SIU\SQ\Lib\errores\error_negocio;
use SIU\SQ\Lib\lib;

class dao_ventas extends dao
{
    public function get_info_personalizada($id_venta)
    {
        $sql = "SELECT 
                    id,
                    id_venta,
                    datos
                FROM 
                    ventas_info_personalizada 
                WHERE 
                    id_venta = ". $id_venta . ";";
        $rs = $this->entorno()->db()->consultar($sql);
        if (count($rs) == 1) {
            return $rs;
        }
        return null;
    }

    public function get_info_personalizada_por_entidad($id_venta, $entidad)
    {
        $datos = null;
        $info_personalizada = $this->get_info_personalizada($id_venta);
        if (!empty($info_personalizada)) {
            if (count($info_personalizada) == 1) {
                $info_personalizada_decode = json_decode(array_a_utf8($info_personalizada[0]['datos']));
                if (json_last_error() != JSON_ERROR_NONE) {
                    lib::entorno()->log()->error(__METHOD__ . ": Error JSON: No se pudo decodificar la info personalizada de la venta");
                    throw new error_negocio("No se pudo decodificar la info personalizada de la venta ID: '" . $id_venta );
                }
                foreach ($info_personalizada_decode as $info) {
                    if ($entidad == $info->entidad) {
                        $datos = $info->datos;
                    }
                }
            } else {
                $msg = "Se encontraron '" . count($info_personalizada) . "' registros de info_personalizada asociados a la venta ID: '" . $id_venta . "' cuando solo se permite 1.";
                lib::entorno()->log()->error(__METHOD__ . ": " . $msg);
                throw new error_negocio($msg);
            }
        }
        if ($datos) {
            return $datos;
        } else {
            $msg = "";
            lib::entorno()->log()->notice($msg);
            return;
        }
    }

    public function get_cobranza($id_venta)
    {
        $sql = "
            SELECT
                c.importe,
                c.id_medio_pago,
                c.id_unidad_venta,
                c.id_comprobante,
                c.id_cliente
            FROM
                cobranzas c 
            LEFT JOIN cobranzas_ventas cv ON c.id = cv.id_cobranza
            LEFT JOIN ventas v ON v.id = cv.id_venta
            WHERE
                v.id = ". $id_venta ."
            ;";

        return $this->entorno()->db()->consultar($sql);
    }
}
