<?php
namespace SIU\SQ\Lib\entorno;

use SIU\SQ\Lib\errores\error;

class entorno
{
    protected $db;
    protected $perfil_de_datos;
    protected $log;
    protected $phinx;

    /**
     *
     * @return \Monolog\Logger
     */
    public function log()
    {
        if (!isset($this->log)) {
            throw new error('Monolog no configurado');
        }
        return $this->log;
    }
    
    public function set_log($log)
    {
        $this->log = $log;
    }

    /**
     *
     * @return \Phinx\Console\PhinxApplication
     */
    public function phinx()
    {
        if (!isset($this->phinx)) {
            throw new error('Phinx no configurado');
        }
        return $this->phinx;
    }

    public function set_phinx($phinx)
    {
        $this->phinx = $phinx;
    }

    /**
     *
     * @return SIU\SQ\Lib\db\db_pdo
     */
    public function db()
    {
        if (!isset($this->db)) {
            throw new error('DB no configurada');
        }
        return $this->db;
    }
    
    public function set_db($db)
    {
        $this->db = $db;
    }
    
    //--------------------------------------
    //---------- PERFIL DE DATOS -----------
    //--------------------------------------
    public function tiene_perfil_de_datos()
    {
        return $this->perfil_de_datos ? true : false;
    }

    public function perfil_de_datos()
    {
        if (!isset($this->perfil_de_datos)) {
            throw new error('Perfil de datos no configurado');
        }
        return $this->perfil_de_datos;
    }
    
    public function set_perfil_de_datos($perfil_de_datos)
    {
        $this->perfil_de_datos = $perfil_de_datos;
    }
}
