<?php
namespace SIU\SQ\Lib\procesos;

use SIU\SQ\Lib\constantes;

class catalogo extends \SIU\SQ\Lib\entorno\catalogo
{
    public function migrar_version($version, $dir_instalacion=null, $imprime_salida = true)
    {
        return new proceso_migrar_version($version, $dir_instalacion, $imprime_salida, $this->entorno);
    }

    public function validar_instalacion($validar_conexiones_sistemas = array(), $imprime_salida = true)
    {
        return new proceso_validar_instalacion($validar_conexiones_sistemas, $imprime_salida, $this->entorno);
    }

    public function enviar_emails()
    {
        return new proceso_enviar_emails(constantes::PROCESO_ENVIAR_EMAILS, $this->entorno);
    }

    public function crear_usuario_admin($nombre, $email)
    {
        return new proceso_crear_usuario_admin($nombre, $email, constantes::PROCESO_CREAR_USUARIO_ADMIN, $this->entorno);
    }

    public function iniciar_workers()
    {
        return new proceso_iniciar_workers(constantes::PROCESO_INICIAR_WORKERS, $this->entorno, null, constantes::PROCESO_EJECUCION_ESTADO_ACTIVO);
    }
    public function proceso_verificar_actividad_workers()
    {
        return new proceso_verificar_actividad_workers(constantes::PROCESO_VERIFICAR_ACTIVIDAD_WORKERS, $this->entorno);
    }
    
    public function reenviar_mensaje($topicName, $listenerName, $messageId)
    {
        return new proceso_reenviar_mensaje($topicName, $listenerName, $messageId, constantes::PROCESO_REENVIAR_MENSAJE, $this->entorno);
    }
    
    public function generar_facturacion()
    {
        return new proceso_generar_facturacion(constantes::PROCESO_GENERAR_FACTURACION, $this->entorno);
    }
    
    public function revertir_facturacion()
    {
        return new proceso_revertir_facturacion(constantes::PROCESO_REVERTIR_FACTURACION, $this->entorno);
    }
    
    public function confirmar_facturacion()
    {
        return new proceso_confirmar_facturacion(constantes::PROCESO_CONFIRMAR_FACTURACION, $this->entorno);
    }
    
    public function generar_facturas_afip()
    {
        return new proceso_generar_facturas_afip(constantes::PROCESO_GENERAR_FACTURAS_AFIP, $this->entorno);
    }
}
